- Public/Stable/Replaceable
  - add_bugsystem
  - add_build_tool
  - add_docker_env
  - add_test
  - add_test_format
  - add_test_type
  - delete_bugsystem
  - delete_build_tool
  - delete_test
  - delete_test_format
  - delete_test_type
  - personality_plugins
  - replace_test_type
  - verify_needed_test
  - verify_plugin_enabled
  - yetus_add_array_element
  - yetus_del_array_element
  - yetus_relative_dir
  - yetus_sort_and_unique_array
  - yetus_sort_array
  - yetus_ver_array_element
- Public/Stable/Not Replaceable
  - add_version_data
  - common_defaults
  - delete_parameter
  - generate_stack
  - module_file_fragment
  - patchfile_verify_zero
  - yetus_abs
  - yetus_debug
  - yetus_error
  - yetus_find_deepest_directory
  - yetus_run_and_redirect
  - yetus_get_ctime
- Public/Evolving/Replaceable
  - get_artifact_url
- Public/Evolving/Not Replaceable
  - guess_build_tool
  - list_plugins
  - plugin_usage_output
  - reaper_add_name
  - yetus_add_header
  - yetus_add_option
  - yetus_array_to_comma
  - yetus_comma_to_array
  - yetus_file_to_array
  - yetus_generic_columnprinter
- Private/Stable/Replaceable
  - docker_do_env_adds
  - reaper_initialize
  - yetus_array_contains
- Private/Evolving/Replaceable
  - activate_robots
  - pid_kill
  - reaper_coproc_func
  - reaper_finalize_results
  - reaper_post_exec
  - reaper_total_count
  - set_yetus_version

## Public/Stable/Replaceable

### `add_bugsystem`

- Synopsis

    add_bugsystem bugsystem

- Description

Add the given bugsystem type

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | Yes

### `add_build_tool`

- Synopsis

    add_build_tool build tool

- Description

Add the given build tool type

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | Yes

### `add_docker_env`

- Synopsis

    add_docker_env envname ...

- Description

Queue env vars to add to the docker env

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | Yes

### `add_test`

- Synopsis

    add_test test

- Description

Add the given test type

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | Yes

### `add_test_format`

- Synopsis

    add_test_format test format

- Description

Add the given test format type

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | Yes

### `add_test_type`

- Synopsis

    add_test_type plugin

- Description

Add the given test type

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | Yes

### `delete_bugsystem`

- Synopsis

    delete_bugsystem bugsystem

- Description

Remove the given bugsystem type

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | Yes

### `delete_build_tool`

- Synopsis

    delete_build_tool build tool

- Description

Remove the given build tool type

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | Yes

### `delete_test`

- Synopsis

    delete_test test

- Description

Remove the given test type

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | Yes

### `delete_test_format`

- Synopsis

    delete_test_format test format

- Description

Remove the given test format type

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | Yes

### `delete_test_type`

- Synopsis

    delete_test_type plugin

- Description

Remove the given test type

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | Yes

### `personality_plugins`

- Synopsis

    personality_plugins plug-in list string

- Description

Personality-defined plug-in list

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | Yes

### `replace_test_type`

- Synopsis

    replace_test_type plugin

- Description

Add the given test type

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | Yes

### `verify_needed_test`

- Synopsis

    verify_needed_test test

- Description

Verify if a given test was requested

- Returns

0 = yes

1 = no

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | Yes

### `verify_plugin_enabled`

- Synopsis

    verify_plugin_enabled test

- Description

Determine if a plugin was enabled by the user ENABLED_PLUGINS must be defined

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | Yes

### `yetus_add_array_element`

- Synopsis

    yetus_add_array_element arrayname element

- Description

Add the element if it is not present in the given array

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | Yes

### `yetus_del_array_element`

- Synopsis

    yetus_del_array_element arrayname element

- Description

Check if an array has a given value

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | Yes

### `yetus_relative_dir`

- Synopsis

    yetus_relative_dir dirpath filepath

- Description

is a given path relative to given dirpath?

- Returns

1 - no, path

0 - yes, path - dirpath

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | Yes

### `yetus_sort_and_unique_array`

- Synopsis

    yetus_sort_and_unique_array arrayvar

- Description

Sort and unique an array by its elements

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | Yes

### `yetus_sort_array`

- Synopsis

    yetus_sort_array arrayvar

- Description

Sort an array by its elements

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | Yes

### `yetus_ver_array_element`

- Synopsis

    yetus_ver_array_element arrayname element

- Description

Check if an arrayname has a given value

- Returns

## @returns 0 = yes

## @returns 1 = no

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | Yes

## Public/Stable/Not Replaceable

### `add_version_data`

- Synopsis

    add_version_data executable name version

- Description

Report on executable versions

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `common_defaults`

- Synopsis

    common_defaults

- Description

Setup the default global variables

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `delete_parameter`

- Synopsis

    delete_parameter parameter

- Description

remove entries from paramater tracker

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `generate_stack`

- Synopsis

    generate_stack

- Description

generate a stack trace when in debug mode

- Returns

exits

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `module_file_fragment`

- Synopsis

    module_file_fragment module

- Description

Convert the given module name to a file fragment

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `patchfile_verify_zero`

- Synopsis

    patchfile_verify_zero log filename

- Description

if patch-level zero, then verify we aren't just adding files

- Returns

$?

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `yetus_abs`

- Synopsis

    yetus_abs fsobj

- Description

Given a filename or dir, return the absolute version of it

- Returns

0 success

1 failure

stdout abspath

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `yetus_debug`

- Synopsis

    yetus_debug string

- Description

Print a message to stderr if –debug is turned on

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `yetus_error`

- Synopsis

    yetus_error string

- Description

Print a message to stderr

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `yetus_find_deepest_directory`

- Synopsis

    yetus_find_deepest_directory array fn

- Description

find the deepest entry of a directory array NOTE: array and filename MUST be absolute paths

- Returns

dir if match

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `yetus_run_and_redirect`

- Synopsis

    yetus_run_and_redirect filename command [..]

- Description

run the command, sending stdout and stderr to the given filename

- Returns

$?

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

### `yetus_get_ctime`

- Synopsis

    yetus_get_ctime

- Description

Get the date in ctime format

- Returns

ctime

Classification | Level
--- | ---
Audience | Public
Stability | Stable
Replaceable | No

## Public/Evolving/Replaceable

### `get_artifact_url`

- Synopsis

    get_artifact_url

- Description

Get the base URL of the artifacts

- Returns

urlstring

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | Yes

## Public/Evolving/Not Replaceable

### `guess_build_tool`

- Synopsis

    guess_build_tool

- Description

attempt to guess what the build tool should be

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `list_plugins`

- Synopsis

    list_plugins

- Description

List all installed plug-ins, regardless of whether they have been enabled

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `plugin_usage_output`

- Synopsis

    plugin_usage_output array

- Description

Print the plugin's usage info

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `reaper_add_name`

- Synopsis

    reaper_add_name

- Description

Add a regex to the reaper's checklist NOTE: Users WILL override anything added before argument parsing!

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `yetus_add_header`

- Synopsis

    yetus_add_header header

- Description

Add a header to the usage output

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `yetus_add_option`

- Synopsis

    yetus_add_option subcommand subcommanddesc

- Description

Add an option to the usage output

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `yetus_array_to_comma`

- Synopsis

    yetus_array_to_comma arrayname string

- Description

Convert an array to a comma-delimited string

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `yetus_comma_to_array`

- Synopsis

    yetus_comma_to_array arrayname string

- Description

Convert a comma-delimited string to an array

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `yetus_file_to_array`

- Synopsis

    yetus_file_to_array arrayname file

- Description

Convert a file to an array. Comments on the beginning of the line are stripped.

- Returns

0 for success

1+ for failure

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

### `yetus_generic_columnprinter`

- Synopsis

    yetus_generic_columnprinter array

- Description

Print a screen-size aware two-column output

- Returns

Nothing

Classification | Level
--- | ---
Audience | Public
Stability | Evolving
Replaceable | No

## Private/Stable/Replaceable

### `docker_do_env_adds`

- Synopsis

    docker_do_env_adds

- Description

Do the work to add the env vars onto the Docker cmd

- Returns

Nothing

Classification | Level
--- | ---
Audience | Private
Stability | Stable
Replaceable | Yes

### `reaper_initialize`

- Synopsis

    reaper_initialize arguments

- Description

Initialize the reaper

- Returns

Nothing

Classification | Level
--- | ---
Audience | Private
Stability | Stable
Replaceable | Yes

### `yetus_array_contains`

- Synopsis

    yetus_array_contains element array

- Description

Check if an array has a given value

- Returns

## @returns 0 = yes

## @returns 1 = no

Classification | Level
--- | ---
Audience | Private
Stability | Stable
Replaceable | Yes

## Private/Evolving/Replaceable

### `activate_robots`

- Synopsis

    activate_robots

- Description

import and set defaults based upon any auto-detected automation

- Returns

Nothing

Classification | Level
--- | ---
Audience | Private
Stability | Evolving
Replaceable | Yes

### `pid_kill`

- Synopsis

    pid_kill pid

- Description

Kill a process id

- Returns

Nothing

Classification | Level
--- | ---
Audience | Private
Stability | Evolving
Replaceable | Yes

### `reaper_coproc_func`

- Synopsis

    reaper_coproc_func

- Description

Reaper coprocessor function that runs outside the law

- Returns

Nothing

Classification | Level
--- | ---
Audience | Private
Stability | Evolving
Replaceable | Yes

### `reaper_finalize_results`

- Synopsis

    reaper_finalize_results jdkname

- Description

Reaper output to the user

- Returns

Nothing

Classification | Level
--- | ---
Audience | Private
Stability | Evolving
Replaceable | Yes

### `reaper_post_exec`

- Synopsis

    reaper_post_exec module testlog testfrag

- Description

Run the reaper

- Returns

Nothing

Classification | Level
--- | ---
Audience | Private
Stability | Evolving
Replaceable | Yes

### `reaper_total_count`

- Synopsis

    reaper_total_count jdkname

- Description

Reaper output to the user

- Returns

Nothing

Classification | Level
--- | ---
Audience | Private
Stability | Evolving
Replaceable | Yes

### `set_yetus_version`

- Synopsis

    set_yetus_version

- Description

set VERSION to the current version if not set

- Returns

Nothing

Classification | Level
--- | ---
Audience | Private
Stability | Evolving
Replaceable | Yes